package jalview.ws2.actions;

import java.util.Collections;
import java.util.List;

import jalview.ws2.actions.api.JobI;
import jalview.ws2.actions.api.TaskEventListener;
import jalview.ws2.actions.api.TaskI;
import jalview.ws2.api.JobStatus;

/**
 * An empty task returned by the {@link NullAction}. Use as a placeholder for
 * testing purposes.
 * 
 * @author mmwarowny
 *
 */
class NullTask implements TaskI<Void>
{
  @Override
  public long getUid()
  {
    return 0;
  }

  @Override
  public JobStatus getStatus()
  {
    return JobStatus.READY;
  }

  @Override
  public List<? extends JobI> getSubJobs()
  {
    return Collections.emptyList();
  }

  @Override
  public void init() throws Exception
  {
  }

  @Override
  public boolean poll() throws Exception
  {
    return true;
  }

  @Override
  public void complete() throws Exception
  {
  }

  @Override
  public Void getResult()
  {
    return null;
  }

  @Override
  public void cancel()
  {
  }

  @Override
  public void addTaskEventListener(TaskEventListener<Void> listener)
  {
  }

  @Override
  public void removeTaskEventListener(TaskEventListener<Void> listener)
  {
  }
}